function init(){
	winResized();
	uiUserResetBlocks();
	uiUserScrollTo();
	uiUsersResInit(); // Init stuff for resources drag & drop
	uiUsersUsrInit(); // Init stuff for users drag & drop
	dd.prePickFunction=uiUsersResPrePick;
}
function winResized(){
	alignBottom(dgi('usersListFrame'),winMe)
	alignBottom(dgi('userFrame'),winMe)
	alignBottom(dgi('linkedResourcesFrame'),winMe,5,140)
	alignBottom(dgi('uiUsersBlocksDiv'),winMe,12)
	if(dgi('subUsersFrame')) dgi('subUsersFrame').style.height=Math.max(60,(winMe.getInnerHeight()/4-50))+'px'
	uiUsersResInit();
}
function uiUserScrollTo(id){
	if(!id) id=uiUserSelected;
	dgi('uiUsersBlocksDiv').scrollTop=dgi('userBlock_'+id).offsetTop+dgi('userBlock_'+id).offsetHeight-dgi('uiUsersBlocksDiv').offsetHeight;

}
/**
 * Create user
 */
// Open a popup asking for user type, name and password
function uiUserCreate(){wl.UIWebPopup('/local/uiUsers/newUser.php',uiUserCreateCB)}

// Get result of data entered into poupup, send back to server for processing
function uiUserCreateCB(ud){wl.asr.send({'userCreate':ud})}

// Delete user
function uiUserDelete(id){
	if(!wl.confirm(delConfCapt.replace(/%1/,dgi('uiUsersDataName').value))) return;
	wl.asr.send({'userDelete':id});
}
// Select user
function uiUserSelect(id){
	if(uiUsersDataNameChangedTO) {
		clearTimeout(uiUsersDataNameChangedTO); uiUsersDataNameChangedTO=0;
		uiUsersDataNameChangedApply();
	}
	if(uiUsersDataHintChangedTO) {
		clearTimeout(uiUsersDataHintChangedTO); uiUsersDataHintChangedTO=0;
		uiUsersHintChangedApply();
	}
	if(id==uiUserSelected) return;

	// Show delete icon for selected user only
	for(var i=0;i<users.length;i++){
		if(dgi('del_'+users[i])) dgi('del_'+users[i]).style.display=((users[i]==id)?'':'none')
		if(users[i]==id) wl.blockItem('userBlock_'+id).select();
	}
	wl.asr.send({'userSelect':1,'userId':id})
	uiUserSelected=id;

	return true;
}
// Send mail invitation
function uiUserSendInvitation(id){wl.asr.send({'userSendInvitation':1,'userId':id})}

/**
 * Activate / deactivage user
 * @param id: user id
 * @param optional doActivate: set to 0 or 1 if called from activation / deactivation button in user config
 */
function uiUserActivated(id,doActivate){
	if(doActivate) dgi('activated_'+id).checked=true;
	if(doActivate===0) dgi('activated_'+id).checked=false;

	var act=dgi('activated_'+id).checked;
	$('uiUsersActWarning').e.verticalFadeInOut(!act)
	$('userActivateLink').style.display=(act)?'':'none';
	winResized();
	uiUserUpdate('activated',act,id)
}

/**
 * Send data for update
 */
function uiUserUpdate(dataName,dataValue,id){
	wl.asr.send({'updateData':dataName,'updateValue':dataValue,'userId':((id)?id:uiUserSelected)})
}

// Name
var uiUsersDataNameChangedTO;
function uiUsersDataNameChanged(n){
	dgi('uiUserBlockName'+uiUserSelected).innerHTML=n.value;
	if(uiUsersDataNameChangedTO) clearTimeout(uiUsersDataNameChangedTO);
	uiUsersDataNameChangedTO=W.setTimeout("uiUsersDataNameChangedApply()",1500)
	wl.event.emit("user",{"rename":1,"id":uiUserSelected,"name":n.value})
}
function uiUsersDataNameChangedApply(){
	uiUsersDataNameChangedTO=0;
	uiUserUpdate('name',dgi('uiUsersDataName').value);
}

// Icon
function uiUserChangeIcon(){wl.UIWebPopup('/local/uiUsers/iconUser.php?userId='+uiUserSelected,uiUserChangeIconCB)}
function uiUserChangeIconCB(newIcon){
	dgi("selUserIcon").src='/gfx/icons/'+newIcon;
	dgi("uiUserBlockIcon"+uiUserSelected).src='/gfx/icons/'+newIcon;
	uiUserUpdate('icon',newIcon);
}

// Authentication method
function uiUsersDataAuthenticationChanged(auth){
	if(auth=='password') {
		uiUsersPwdSet(1);
		dgi('uiUsersDataHint').disabled=false;
	}
	else {
		uiUserUpdate('authenticationMethod','noAuthentication');
		dgi('uiUsersDataHint').disabled=true;
	}
}
// Password
var uiUsersPwdSetFromSelect;
function uiUsersPwdSet(fromSelect){
	if(fromSelect) dgn("passwordSelect").value="noAuthentication"
	uiUsersPwdSetFromSelect=fromSelect;
	wl.UIWebPopup('/local/uiUsers/password.php?userName='+dgi("uiUsersDataName").value,uiUsersPwdSetCB)
}
function uiUsersPwdSetCB(res){
	if(res!="") {
		uiUserUpdate('password',res);
		dgi('uiUsersDataHint').disabled=false;
	}
	dgi('uiUsersDataAuthenticationNA').selected=true;
}
// Hint
var uiUsersDataHintChangedTO;
function uiUsersDataHintChanged(n){
	if(uiUsersDataHintChangedTO) clearTimeout(uiUsersDataHintChangedTO);
	uiUsersDataHintChangedTO=setTimeout("uiUsersHintChangedApply()",1500)
}
function uiUsersHintChangedApply(){
	uiUsersDataHintChangedTO=0;
	uiUserUpdate('hint',dgi('uiUsersDataHint').value);
}
// Toggle advanced configuration
function uiUsersToggleAdvancedConfig(){
	uiShowAdvancedConfig=1-uiShowAdvancedConfig;
	if(uiShowAdvancedConfig){
		wl.anim({'item':$('advancedConfigDiv'),
				'duration':350,
				'extraParameters':{'baseHeight':55},
				'callbackStep':winResized,
				'function':function(p,anim){
					return {'height':Math.max(1,p*p*anim.extraParameters.baseHeight),'display':'','opacity':p*p*p}
				}
		});
		dgi('advancedConfigFoldIco').style.display='none';
		dgi('advancedConfigUnfoldIco').style.display='';
	}
	else{
		wl.anim({'item':$('advancedConfigDiv'),
				'duration':350,
				'callbackStep':winResized,
				'function':function(p,anim){
					return {'height':Math.max(1,(1-p*p)*50),'opacity':(1-p*p*p),'display':(p<1)?'':'none'}
				}
		});
		dgi('advancedConfigUnfoldIco').style.display='none';
		dgi('advancedConfigFoldIco').style.display='';
	}
	winResized();
	wl.asr.send({'userShowAdvancedConfig':uiShowAdvancedConfig})
}
// DL limit
function uiUsersDataDLLimitChanged(v){
	if(isNaN(v.value) || v.value<0) v.style.color='red';
	else{
		v.style.color='';
		uiUserUpdate('downloadSpeedLimit',v.value)
	}
}

// IP filter
function uiUsersIPSet(){
	wl.UIWebPopup('/local/IPFilter.php?userFile='+uiUserFile,uiUsersIPSetCB)
}
function uiUsersIPSetCB(res){
	if(res!=0) btSetIcon('uiUsersIPBt','/gfx/warning.png'); else btSetIcon('uiUsersIPBt','/gfx/ahead.png');
}

// Select a theme
function uiUsersSelectTheme(){wl.UIWebPopup('/local/themeSelection.php?userFile='+uiUserFile,uiUsersSelectThemeCB)}
function uiUsersSelectThemeCB(res){uiUserUpdate('theme',res)}

// Add a resource
function uiUsersAddResource(){wl.UIWebPopup('/local/uiUsers/bindResourceToUser.php?selectedUserId='+uiUserSelected,uiUsersAddResourceCB)}
function uiUsersAddResourceCB(r){
	// User requested a new resource creation
	if(r=='createNewResource') wl.asr.send({'userId':uiUserSelected,'userCreateNewResource':r});
	// Else user's resources modified
	else wl.asr.send({'userId':uiUserSelected,'userAddResources':r})
}

// Remove a resource
function uiUsersResDel(rid){fade('uiUsersResBlock_'+rid,1,0,10,'uiUsersResDelCB("'+rid+'")')}
function uiUsersResDelCB(rid){wl.asr.send({'removeResource':rid,'userId':uiUserSelected})}

// Change resource displayed at user's login
function uiUsersResLogin(rid){
	if(!rid) rid='';
	uiUserUpdate('displayResourceAtLogin',rid);
}

/*******************************************************************************************
 * subUsers management
 ******************************************************************************************/

/**
 * Add sub user button click
 */
function uiUsersAddSubUser(){wl.UIWebPopup('/local/uiUsers/password.php?subUser=1',uiUsersAddSubUserCB)}

// Name / password form for subUser creation allback
function uiUsersAddSubUserCB(r){wl.asr.send({'userId':uiUserSelected,'userCreateSubUser':r})}

// Delete subUser
function uiUsersDeleteSubUser(subUserId){
	var capt=wl.capt.genConfirmSuppress.replace(/%1/,'"'+dgi('subUser'+subUserId).innerHTML+'"');
	if(confirm(capt)) wl.asr.send({'userId':uiUserSelected,'userDeleteSubUser':1,'subUserId':subUserId})
}

// Reset subUserPassword
var tmpSubUserId;
function uiUsersSubUserResetPassword(subUserId){
	tmpSubUserId=subUserId;
	wl.UIWebPopup('/local/uiUsers/password.php?subUser=1&resetPassword=1&noPasswordAllowed=1',uiUsersSubUserResetPasswordCB)
}
function uiUsersSubUserResetPasswordCB(r){wl.asr.send({'userId':uiUserSelected,'subUserId':tmpSubUserId,'userSubUserResetPassword':1,'newPassword':r})}


/*******************************************************************************************
 * Resources management
 ******************************************************************************************/

// Set resource frame scroll position at initial position after an async update
var uiUsersResScroll=0;
function uiUsersResScrollGet(){uiUsersResScroll=dgi('linkedResourcesScroll').scrollTop}
function uiUsersResScrollSet(){dgi('linkedResourcesScroll').scrollTop=uiUsersResScroll}
var resPos={},ddObjStartPos,ddObjPos,ddObjId;

function uiUsersResInit(){
	W.resCont=dgi('linkedResourcesScroll');
	resPos={};
	var i,e,elts=W.resCont.childNodes,nb=0;
	// Remove previous draggable resources (if any)
	for(i in dd.elements) {e=dd.elements[i]; if(e && e.id && !e.id.indexOf('uiUsersResBlock_')) e.del()}
	// Create new ones, and store default positions
	for(i in elts){
		if(!(elts[i].id)) continue;
		ADD_DHTML(elts[i].id+CURSOR_MOVE+DETACH,1);
		e=dd.elements[elts[i].id];
		e.setPickFunc(uiUsersResPick);
		e.setDragFunc(uiUsersResDrag);
		e.setDropFunc(uiUsersResDrop);
		resPos[elts[i].id]={'x':e.x,'y':e.y,'pos':nb,'id':elts[i].id}
		nb++;
	}
}

// Workaround for event not reaching delete and open-on-connection buttons: check if event is targeted at a control and cancel pick if so
function uiUsersResPrePick(a,e){
	if(!e) e=event;
	var t=e.target||e.srcElement;
	if(t && t.tagName!='FIELDSET' && t.onclick){t.onclick();return 0}
	return 1;
}

// Called when a resource is picked start timer to manage container scroll and displaced resources positions
function uiUsersResPick(e){
	ddObjStartPos=resPos[dd.obj.id].pos;
	ddObjId=dd.obj.id;
	ddObjPos=undefined;
	W.dragScrollInt=setInterval(function(){
		var p=W.resCont,dy=dd.obj.y-actualOffsetTop(p),t,x,y;

		// container scroll
		if(dy<0 || (dy=dd.obj.y-actualOffsetBottom(p)+dd.obj.h)>0) 	p.scrollTop+=dy;
		if(ddObjPos==undefined) return;

		// other res displacement
		t=uiUsersResTargets();
		for(i in t) if(i!=dd.obj.id) {
			e=dd.elements[i];
			e.moveTo((resPos[t[i]].x+e.x)/2,(resPos[t[i]].y+e.y)/2);
		}
	},10);
}
// Determine dragged object's position in all items
function uiUsersResDrag(){
	var nb=0,i,e,x=dd.obj.x,y=dd.obj.y+W.resCont.scrollTop,w=dd.obj.w/2,h=dd.obj.h/2,nbItems=count(resPos);
	ddObjPos=-1;
	for(i in resPos){
		if(i==dd.obj.id){
			if(ddObjPos==-1) ddObjPos=nb;
		}
		else{
			e=resPos[i];
			if(x+w>e.x && x<e.x+w+5 && y+h>e.y && y<e.y+h+7) ddObjPos=nb;
			else if(x+w>e.x && y+h>e.y && nb==nbItems-1) ddObjPos=nb;
		}
		nb++;
	}
}
// Object droped
function uiUsersResDrop(){
	var i,t;
	if(W.dragScrollInt) clearInterval(W.dragScrollInt);W.dragScrollInt=0;
	// Reset objects pos
	t=uiUsersResTargets();
	for(i in t) if(1||i!=ddObjId) dd.elements[i].moveTo(resPos[t[i]].x,resPos[t[i]].y);
	wl.asr.send({'userResMove':ddObjId.substr(ddObjId.indexOf('_')+1),'target':resPos[t[ddObjId]].pos,'userId':uiUserSelected})
}

/**
 * @desc Return an array associating to each item's id the id of the item over which it will have to be moved
 */
function uiUsersResTargets(){
	var p=i,rp,pos=0,tgt,t={};
	for(i in resPos) {
		tgt=resPos[i];
		if(tgt.pos==ddObjPos) t[ddObjId]=i;
		if(i==ddObjId) continue;
		if((tgt.pos<ddObjPos && tgt.pos<ddObjStartPos) || (tgt.pos>ddObjPos && tgt.pos>ddObjStartPos)) {}
		else if(ddObjPos<ddObjStartPos && tgt.pos>=ddObjPos) tgt=wl.arrayNext(resPos,i);
		else tgt=wl.arrayPrev(resPos,i);
		t[i]=tgt.id;
	}
	return t;
}





/*******************************************************************************************
 * Users position management
 ******************************************************************************************/
var usrPos,usrCont,usrDy;
var usrDraggedDy; // Delta between dragged object and it's target position, used for "pushing" elements
var usrMinY,usrMaxY; // Max & Min Y coordinate of block element
function uiUserResetBlocks(){
	for(var i=0;i<users.length;i++) {
		dgi('userBlock_'+users[i]).style.top=((i==0)?0:5+dgi('userBlock_'+users[i-1]).offsetTop+Math.max(70,dgi('userBlock_'+users[i-1]).offsetHeight))+'px';
	}
}

function uiUsersUsrInit(){
	usrCont=dgi('uiUsersBlocksDiv');
	usrPos={};usrDy={};
	var i,e,elts=[],max=0;
	usrMinY=999;usrMaxY=0;

	// Remove previous draggable resources (if any)
	for(i in dd.elements) {e=dd.elements[i]; if(e && e.id && !e.id.indexOf('userBlock_')) e.del()}

	// Reset blocks positions
	uiUserResetBlocks();

	// Sort user blocks items on y position
	for(i=0;i<usrCont.childNodes.length;i++) {
		n=usrCont.childNodes[i];
		if(n.id && n.id.indexOf('userBlock_')!=-1) elts.push(n);
	}
	elts=elts.sort(function(a,b){return a.offsetTop-b.offsetTop})

	// Create new ones, and store default positions
	for(i=0;i<elts.length;i++){
		if(!dd.elements[elts[i].id]) ADD_DHTML(elts[i].id+CURSOR_S_RESIZE+DETACH+MAXOFFRIGHT+0+MAXOFFLEFT+0+PICKDELAY+400,1);
		e=dd.elements[elts[i].id];
		e.setPickFunc(uiUsersUsrPick);
		e.setDragFunc(uiUsersUsrDrag);
		e.setDropFunc(uiUsersUsrDrop);
		e.maxXPos=e.x;
		e.minXPos=e.x;
		e.minYPos=usrCont.offsetTop-20;
		e.maxYPos=e.minYPos+usrCont.offsetHeight;
		max=Math.max(max,e.div.offsetTop)
		usrMinY=Math.min(usrMinY,e.y)
		usrMaxY=Math.max(usrMaxY,e.y)
		usrPos[elts[i].id]={'x':e.x,'y':e.y,'pos':i,'id':elts[i].id}
	}

	// Add a filler to prevent weird behaviour when last block element moves
	if(!dgi('filler')) $('filler').e.create('DIV',{'style':'height:'+(max+e.div.offsetHeight)+'px;width:0px;position:relative'},usrCont);
}

// Called when an user is picked: start timer to manage container scroll and displaced users positions
function uiUsersUsrPick(e){
	ddObjStartPos=usrPos[dd.obj.id].pos;
	ddObjId=dd.obj.id;
	ddObjPos=-2;
	// Workaround: remove copy of icon, generated by onload=fade(this)
	var id='uiUserBlockIcon'+ddObjId.substr(10),imgs=D.getElementsByTagName('IMG');
	for(i=0;i<imgs.length;i++) if(imgs[i].id==id && imgs[i].parentNode.parentNode.style.visibility=='hidden')
		imgs[i].style.visibility='hidden';

	// Scroll detection loop
	W.dragScrollInt=setInterval(function(){
		var p=W.usrCont,dy=dd.obj.y-actualOffsetTop(p),t,x,y,ampl;

		// container scroll
		if(dy<0 || (dy=dd.obj.y-actualOffsetBottom(p)+dd.obj.h)>0) 	p.scrollTop+=dy;
		if(ddObjPos==-2) return;

		// other users displacement
		t=uiUsersUsrTargets();
		y=dd.obj.y+W.usrCont.scrollTop;
		for(i in t) if(i!=dd.obj.id) {
			e=dd.elements[i];
			ampl=Math.abs(usrPos[t[i]].pos-usrPos[t[dd.obj.id]].pos);

			if(ampl<3) ampl=Math.pow(Math.abs(usrDraggedDy),0.7)/Math.pow(ampl,0.8); else ampl=0;

			if(usrPos[t[i]].y>y && usrDraggedDy>0) dy=ampl;
			else if(usrPos[t[i]].y<y && usrDraggedDy<0) dy=-ampl;
			else dy=0;

			destY=Math.min(usrMaxY,Math.max(usrMinY,usrPos[t[i]].y+dy));

			e.moveTo(false,(destY+e.y)/2);
		}
		// displace dragged object a bit away from target
		dd.obj.div.style.marginTop=(((usrDraggedDy<0)?1:-1)*Math.pow(Math.abs(usrDraggedDy),0.7))+'px'
	},10);
}

// Determine dragged object's sequential position in all items
function uiUsersUsrDrag(){
	var nb=0,i,e,x=dd.obj.x,y=dd.obj.y+W.usrCont.scrollTop,w=dd.obj.w/2,h=dd.obj.h/2,nbItems=count(usrPos);
	ddObjPos=-1;
	for(i in usrPos){
		if(i==dd.obj.id){
			if(ddObjPos==-1) ddObjPos=nb;
		}
		else{
			e=usrPos[i];
			if(x+w>e.x && x<e.x+w+5 && y+h>e.y && y<e.y+h+7) ddObjPos=nb;
			else if(x+w>e.x && y+h>e.y && nb==nbItems-1) ddObjPos=nb;
		}
		nb++;
	}
	usrDraggedDy=y-usrPos[(uiUsersUsrTargets())[dd.obj.id]].y; // Delta between dragged object and it's target position
}
// Object dropped
function uiUsersUsrDrop(){
	var i,t,nb=0,elts=[];
	if(W.dragScrollInt) clearInterval(W.dragScrollInt);W.dragScrollInt=0;
	dd.obj.div.style.marginTop='0px';

	// Reset objects pos
	t=uiUsersUsrTargets();
	for(i in t) {dd.elements[i].moveTo(false,usrPos[t[i]].y)}

	// Rebuild users array
	for(i=0;i<usrCont.childNodes.length;i++) {
		n=usrCont.childNodes[i];
		if(n.id && n.id.indexOf('userBlock_')!=-1) elts.push(n);
	}
	// Sort user blocks items on y position
	elts=elts.sort(function(a,b){return a.offsetTop-b.offsetTop})
	for(i=0;i<elts.length;i++) users[i]=elts[i].id.substr(10);

	wl.asr.send({'userOrder':users.toString()})
	uiUsersUsrInit();
}

/**
 * @desc Return an array associating to each item's id the id of the item over which it will have to be moved
 */
function uiUsersUsrTargets(){
	var p=i,rp,pos=0,tgt,t={};
	for(i in usrPos) {
		tgt=usrPos[i];
		if(tgt.pos==ddObjPos) t[ddObjId]=i;
		if(i==ddObjId) continue;
		if((tgt.pos<ddObjPos && tgt.pos<ddObjStartPos) || (tgt.pos>ddObjPos && tgt.pos>ddObjStartPos)) {}
		else if(ddObjPos<ddObjStartPos && tgt.pos>=ddObjPos) tgt=wl.arrayNext(usrPos,i);
		else tgt=wl.arrayPrev(usrPos,i);
		t[i]=tgt.id;
	}
	return t;
}