<?php
/**
 * Full size image viewer
 *
 * display page with an image viewer, and 3 buttons : previous, next, slideshow
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */
require(INCLUDE_DIR.'viewFunctions.php');

if(!isset($_POST['data1']) || !isset($_POST['data2'])) exit;

vfViewFile(cfUTF8Decode(($_POST['data1'])),
		cfUTF8Decode(($_POST['data2'])),
		(isset($_POST['data3']))?(cfUTF8Decode(($_POST['data3']))):(''),
		(isset($_POST['data4'])) ? (cfUTF8Decode(($_POST['data4']))) : (''),
		(isset($_POST['data5'])?(cfUTF8Decode(($_POST['data5']))):(''))
		);
?>
