<?php
/**
 * redirection to local website
 *
 * Redirect to index file of website defined in resource configuration file
 * website is accessible through an alias defined in apache httpd config
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

if(!cfRGetVar('alias') || !cfRGetVar('index')) {
	require_once(INCLUDE_DIR.'outputFunctions.php');
	outDisplayErrorPage(cfCaption('errorResourceFileIncorrect'));
	exit();
}
header('Location: /'.cfRGetVar('alias').'/'.cfRGetVar('index'));
?>
