function bgConfigLink(){openResource('/res/administration/config/main.php','-1',winCaptionConfig,winIconConfig,{'dWW':340,'dWH':200})}

/**
 * Called when mainFrame page HTML is loaded
 */
function bgHTMLLoaded(){
	winDeskUpdate();
	if(W.backgroundOnload) W.backgroundOnload();
	iconRestorePosition();
	iconAnimate();
	bgSetWindows();
	bodyResized();
}
function bgBodyLoaded(){
	setWallpaper();
	cmi=new Array(
		ContextMenuItem(winIconConfig,winCaptionConfig,'bgConfigLink()'),
		ContextMenuItem("sep"),
		ContextMenuItem(winIconLogout,winCaptionLogout,'logout()')
	);
	ContextMenuAttach(dgi("wpDiv"),cmi);
	D.body.oncontextmenu=function(){return false}
}

/**
 * Called on window resize
 */
function bodyResized(){
	winDeskUpdate();
	if(W.iconAdjustIcons) iconAdjustIcons();
	if(W.winAdjustWindows) winAdjustWindows();
	if(W.menuWinBarResized) menuWinBarResized();
	if(W.sNotesResetPos) sNotesResetPos();
}

/**
 * Resource opening script
 * fileSrc: URL of script
 */
function openResource(fileSrc, rId, rLabel, rIcon, opt){

	// Ensure page is reloaded by adding a random GET
	var resourceURL=fileSrc + "?resId="+rId+"&rnd="+Math.random(),p=winPadding;
	if(!opt) opt={};
	if(!winFrames){D.location=resourceURL;	return}

	// If resource must be opened in it's own window
	if(fileSrc.substr(0,26)=='/res/administration/rDesk/' && (bBrowser=='IE9'||bBrowser=='IE10'||bBrowser=='IE11')) opt.separateWindow=1; // IE9+ WA as strict mode cannot be applied to a frame if an upper frame has quirk
	if(opt.separateWindow) {W.open(resourceURL);return}

	if(winOpenLocation(resourceURL, 'Win_'+(rId), rLabel)=='created') {
		var oW=win('Win_'+(rId));

		if(winClosedPosition['Win_'+(rId)]) {
			var x=Math.max(p.left,winClosedPosition['Win_'+(rId)][0]);
			var y=Math.max(p.top, winClosedPosition['Win_'+(rId)][1]);
			oW.moveTo(x,y);
			oW.resizeTo(Math.min(dd.getWndW()-x-p.right,winClosedPosition['Win_'+(rId)][2]),Math.min(dd.getWndH()-y-p.bottom,winClosedPosition['Win_'+(rId)][3]));
		}
		else {
			if(opt.dWW && opt.dWH){
				defaultWindowWidth=Math.min(dd.getWndW()-p.left-p.right,opt.dWW);
				defaultWindowHeight=Math.min(dd.getWndH()-p.top-p.bottom,opt.dWH);
				oW.moveTo((dd.getWndW()-defaultWindowWidth)/2, (dd.getWndH()-defaultWindowHeight)/2);
				oW.resizeTo(defaultWindowWidth, defaultWindowHeight);
			}
			else {
				if(opt.dWW && opt.dWH){
					oW.resizeInnerTo(opt.dWW,opt.dWH);
					oW.center();
				}
				else {
					// Maximized window not requested and screen too large: show normal window
					if((dd.getWndW()-p.left-p.right>1024 || dd.getWndW()-p.top-p.bottom>800) && !opt.max) {
						oW.resizeTo(Math.min(1000,dd.getWndW()-p.left-p.right),Math.min(780,dd.getWndH()-p.top-p.bottom),true);
						oW.center();
					}
					// Maximized window
					else {
						opt.noAnimation=1;
						oW.maximize(opt);
					}
				}
			}
		}
		oW.setIcon(rIcon);

		if(opt.remoteConfigFile) oW.addControls(winConfigBt(rId,opt));
		oW.show(opt);
	}
}

/**
 * Set wallpaper on background
 * @param src: image src
 * @param position: 'centered', 'tiled', 'stretched'
 */
function setWallpaper(src,position){
	if(src) wallpaper=src; else src=wallpaper;

	if(position) wallpaperPosition=position; else position=wallpaperPosition;
	var wpd=dgi('wpDiv'),wpd2=dgi('wpDiv2'),wpi=dgi('wpImg');

	if(src=='no'||!wallpaper) {
		wpd.innerHTML='';
		wpd.style.backgroundColor='';
		if(src==='no') D.body.style.backgroundImage='none';
		return;
	}

	if(src=='theme') {
		wpd.innerHTML='';wpd.style.background='';
		D.body.style.backgroundColor='';
		D.body.style.backgroundImage='';
		if(tWallpaper) {src=tWallpaper;position=tWallpaperPosition}
		else return;
	}

	if(position=='tiled')	{
		wpd.style.background="url('"+src+"') repeat top left";
		wpd.innerHTML='';
		D.body.style.backgroundImage='none';
		if(src.substr(src.lastIndexOf('/')+1,1)=='-') setBackgroundColor('#'+src.substr(src.lastIndexOf('/')+2,6)); else setBackgroundColor(desktopColor);
	}
	else wpd.style.background='';

	if(position=='stretched'){
		wpd.innerHTML='<'+'img id="wpImg" alt="" style="width:100%;height:100%;visibility:hidden" oncontextmenu="return false" src="'+src+'">';
		D.body.style.backgroundImage='none';
		wpImageStretched.onload=wpStretch;
		wpImageStretched.src=src;
		if(src.substr(src.lastIndexOf('/')+1,1)=='-') setBackgroundColor('#'+src.substr(src.lastIndexOf('/')+2,6)); else setBackgroundColor(desktopColor);
	}
	else if(position=='centered'){
		wpd.innerHTML='<'+'div id="wpDiv2" style="position:absolute;left:50%;top:50%"><'+'img id="wpImg" alt="" style="position:relative;left:-50%;top:-50%" onContextMenu="return false" src="'+src+'" onload="wpCenter();fade(\'wpImg\',0,1)"><'+'/div>'
		if(src.substr(src.lastIndexOf('/')+1,1)=='-') setBackgroundColor('#'+src.substr(src.lastIndexOf('/')+2,6)); else setBackgroundColor(desktopColor);
		D.body.style.backgroundImage='none';
	}
}

/**
 * @desc Center wallpaper
 */
function wpCenter(){
	if(wallpaperPosition!='centered') return;
	var wpi=dgi('wpImg');
	wpi.style.left=-Math.floor(wpi.offsetWidth/2);
	wpi.style.top=-Math.floor(wpi.offsetHeight/2);
}

/**
 * @desc Stretch wallaper
 */
function wpStretch(){
	var i=W.wpImageStretched;
	var w=i.width,h=i.height,img=dgi('wpImg'),imgs=img.style,wpd=dgi('wpDiv');
	// image has an high height/width ratio: use as a stretched pattern
	if(w/h>10||h/w>10) imgs.height=imgs.width='100%';
	else{
		sr=wpd.offsetWidth/wpd.offsetHeight>w/h;
		imgs.width=(sr)?'100%':'auto';
		imgs.height=(sr)?'auto':'100%';
		imgs.marginTop=(sr)?((wpd.offsetHeight-img.offsetHeight)/2)+'px':0;
		imgs.marginLeft=(sr)?0:((wpd.offsetWidth-img.offsetWidth)/2)+'px';
		disconnect(W,'resize',wpStretch)
		connect(W,'resize',wpStretch)
	}
	if(imgs.visibility=='hidden') fade(img);
}

function setBackgroundColor(c){
	if(c==-1) return;
	desktopColor=c;
	D.body.style.backgroundColor=c;
}
function iconAnimate(){
	if(!windowsAnimation || !W.iconsList) return;
	W.iconAnimateInProgress=1;// Used to prevent icons ajust during animation
	var f=function(p,anim){
		if(!anim.rand) anim.rand=0.2*Math.random();
		if(p!=1){p=Math.max(0,p-anim.rand);	p=1-Math.exp(-6*p)*Math.cos(16*p)}
		return {'left':(p*anim.eP.left+100*(p-1))+'px','top':(1*anim.eP.top+100*(1-1))+'px'}
	}
	var i,u,its=[];
	for(i=0;i<iconsList.length;i++) {
		u=iconsList[i];
		it=dgi('resIcon_'+u[0]);
		its.push({'item':it,'eP':{'left':it.offsetLeft,'top':it.offsetTop},'function':function(p,anim){return f(p,anim)}});
	}
	wl.anim({'items':its,'duration':1000,'callbackComplete':function(){W.iconAnimateInProgress=0}});
}
// Display credits popup
function creditsPopup(){
	winOpenLocation('/mainFrame.php?creditsPopup', 'creditsPopup', "")
	with(win('creditsPopup')){
		resizeTo(540,560);
		center();
		show();
		bringToFront();
	}
}

var debug=2;